#include "stdafx.h"
#include "Insert.h"

ROW Mask[]={7,7<<3,7<<6,7<<9,7<<12};
ROW Mask1[]={~7,~(7<<3),~(7<<6),~(7<<9),~(7<<12)};

MoveStats History[MAX_MOVES+1];//History[0] used as guard while calculating NDummy
int Pictures[MAX_MOVES];
int depth;
int EvalMax[15][MAX_DEPTH],EvalDiff[15][MAX_DEPTH];//EvalXXX[move][depth]
int BestMoves[15],NBest;//moves ordered w.r.t. evaluation at current depth: best moves first

char*EngineNames[16]={"Dummy","Random","Eval2","Eval2X","Eval3","Eval3X","Eval2XX","Eval3XX",
											"Eval4X","Eval4XX","Eval5","Eval5X"};

EVALOK INFPLUS(10000,0,0),INFMINUS(0,10000,10000);

//#pragma unmanaged

//Comparing moves for MAX strategy:
int compareMax(const void *arg1, const void *arg2 ){
	if(EvalMax[*(int*)arg1][depth]!=EvalMax[*(int*)arg2][depth])
		return EvalMax[*(int*)arg2][depth]-EvalMax[*(int*)arg1][depth];
	return EvalDiff[*(int*)arg2][depth]-EvalDiff[*(int*)arg1][depth];
}

//Comparing moves for DIFF strategy:
int compareDiff(const void *arg1, const void *arg2 ){
	if(EvalDiff[*(int*)arg1][depth]!=EvalDiff[*(int*)arg2][depth])
		return EvalDiff[*(int*)arg2][depth]-EvalDiff[*(int*)arg1][depth];
	return EvalMax[*(int*)arg2][depth]-EvalMax[*(int*)arg1][depth];
}
